<?php

namespace Drupal\cfrapi\CfrGroupSchema;

abstract class CfrGroupSchema_DecoratorBase implements CfrGroupSchemaInterface {

  /**
   * @var \Drupal\cfrapi\CfrGroupSchema\CfrGroupSchemaInterface
   */
  private $decorated;

  /**
   * The constructor.
   *
   * @param \Drupal\cfrapi\CfrGroupSchema\CfrGroupSchemaInterface $decorated
   */
  public function __construct(CfrGroupSchemaInterface $decorated) {
    $this->decorated = $decorated;
  }

  /**
   * {@inheritdoc}
   */
  public function getConfigurators() {
    return $this->decorated->getConfigurators();
  }

  /**
   * {@inheritdoc}
   */
  public function getLabels() {
    return $this->decorated->getLabels();
  }

  /**
   * {@inheritdoc}
   */
  public function valuesGetValue(array $values) {
    return $this->decorated->valuesGetValue($values);
  }

}
