<?php

namespace Drupal\cfrapi\LegendItem;

class LegendItem implements LegendItemInterface {

  /**
   * @var string
   */
  private $label;

  /**
   * @var string|null
   */
  private $groupLabel;

  /**
   * @param string $label
   * @param string|null $groupLabel
   */
  public function __construct($label, $groupLabel) {
    $this->label = $label;
    $this->groupLabel = $groupLabel;
  }

  /**
   * {@inheritdoc}
   */
  public function getLabel() {
    return $this->label;
  }

  /**
   * {@inheritdoc}
   */
  public function getGroupLabel() {
    return $this->groupLabel;
  }

  /**
   * {@inheritdoc}
   */
  public function withLabels($label, $groupLabel) {
    return new self($label, $groupLabel);
  }

}
