<?php

namespace Drupal\cfrapi\Util;

/**
 * Contains constants to distinguish different array modes.
 */
final class ArrayMode extends UtilBase {

  /**
   * Array mode where keys are always numeric and serial.
   *
   * This is NULL, so that calling code does not need to spell out the constant
   * name for the default value.
   */
  public const SERIAL = NULL;

  /**
   * Array mode where serial numeric keys and assoc string keys are mixed.
   */
  public const MIXED = 1;

  /**
   * Array mode where all keys are treated as associative.
   */
  public const ASSOC = 2;

}
