<?php

namespace Drupal\cfrapi\Util;

use Drupal\cfrapi\Exception\ConfToValueException;
use Drupal\cfrapi\Exception\PhpGenerationNotSupportedException;

final class CodegenFailureUtil extends UtilBase {

  /**
   * @param string $class
   *
   * @throws \Drupal\cfrapi\Exception\PhpGenerationNotSupportedException
   */
  public static function cannotExportObject($class) {
    throw new PhpGenerationNotSupportedException("Cannot export object to PHP.");
  }

  /**
   * @param string $message
   *
   * @throws \Drupal\cfrapi\Exception\PhpGenerationNotSupportedException
   */
  public static function cannotExportClosure($message) {
    throw new PhpGenerationNotSupportedException($message);
  }

  /**
   * @throws \Drupal\cfrapi\Exception\PhpGenerationNotSupportedException
   */
  public static function recursionDetected() {
    throw new PhpGenerationNotSupportedException("Recursion detected.");
  }

  /**
   * @throws \Drupal\cfrapi\Exception\PhpGenerationNotSupportedException
   */
  public static function recursiveArray() {
    throw new PhpGenerationNotSupportedException("Cannot export recursive arrays.");
  }

  /**
   * @param mixed $conf
   * @param string $message
   *
   * @throws \Drupal\cfrapi\Exception\ConfToValueException
   */
  public static function incompatibleConfiguration($conf, $message) {
    throw new ConfToValueException($message);
  }

  /**
   * @param mixed $conf
   * @param string $message
   *
   * @throws \Drupal\cfrapi\Exception\PhpGenerationNotSupportedException
   */
  public static function notSupported($conf, $message) {
    throw new PhpGenerationNotSupportedException($message);
  }

}
