<?php

namespace Drupal\cfrfamily\CfrLegendItem;

use Drupal\cfrapi\Configurator\ConfiguratorInterface;
use Drupal\cfrapi\LegendItem\LegendItem;
use Drupal\cfrapi\PossiblyOptionless\PossiblyOptionlessInterface;
use Drupal\cfrapi\SummaryBuilder\SummaryBuilderInterface;

class CfrLegendItem extends LegendItem implements CfrLegendItemInterface {

  /**
   * @var \Drupal\cfrapi\Configurator\ConfiguratorInterface
   */
  private $configurator;

  /**
   * @param string $label
   * @param string $groupLabel
   * @param \Drupal\cfrapi\Configurator\ConfiguratorInterface $configurator
   */
  public function __construct($label, $groupLabel, ConfiguratorInterface $configurator) {
    parent::__construct($label, $groupLabel);
    $this->configurator = $configurator;
  }

  /**
   * {@inheritdoc}
   */
  public function confGetForm($conf, $label) {
    return $this->configurator->confGetForm($conf, $label);
  }

  /**
   * {@inheritdoc}
   */
  public function confGetSummary($conf, SummaryBuilderInterface $summaryBuilder) {
    return $this->configurator->confGetSummary($conf, $summaryBuilder);
  }

  /**
   * {@inheritdoc}
   */
  public function withLabels($label, $groupLabel) {
    return new self($label, $groupLabel, $this->configurator);
  }

  /**
   * {@inheritdoc}
   */
  public function isOptionless() {
    return $this->configurator instanceof PossiblyOptionlessInterface
      ? $this->configurator->isOptionless()
      : FALSE;
  }

}
