<?php

namespace Drupal\cfrplugindiscovery\ClassFileDiscovery;

use Drupal\cfrplugindiscovery\Util\DiscoveryUtil;

class ClassFileDiscovery implements ClassFileDiscoveryInterface {

  /**
   * {@inheritdoc}
   */
  public function dirNspGetClassFiles($directory, $namespace) {
    DiscoveryUtil::normalizeDirectory($directory);
    DiscoveryUtil::normalizeNamespace($namespace);
    return $this->dirNspFindClassFilesRecursive($directory, $namespace);
  }

  /**
   * @param string $parentDir
   * @param $parentNamespace
   *
   * @return string[]
   *   Format: $[$file] = $class
   */
  private function dirNspFindClassFilesRecursive($parentDir, $parentNamespace) {
    $classFiles = [];
    foreach (scandir($parentDir, SCANDIR_SORT_ASCENDING) as $candidate) {
      if ('.' === $candidate[0]) {
        continue;
      }
      $path = $parentDir . '/' . $candidate;
      if ('.php' === substr($candidate, -4)) {
        $name = substr($candidate, 0, -4);
        $class = $parentNamespace . $name;
        $classFiles[$path] = $class;
      }
      elseif (is_dir($path)) {
        $classFiles += $this->dirNspFindClassFilesRecursive($path, $parentNamespace . $candidate . '\\');
      }
    }
    return $classFiles;
  }

}
