<?php

namespace Drupal\cfrrealm\DefinitionToConfigurator;

use Drupal\cfrapi\Context\CfrContextInterface;
use Drupal\cfrfamily\DefinitionToConfigurator\DefinitionToConfiguratorInterface;

class DefinitionToConfigurator_Proxy implements DefinitionToConfiguratorInterface {

  /**
   * @var \Drupal\cfrfamily\DefinitionToConfigurator\DefinitionToConfiguratorInterface
   */
  private $instance;

  /**
   * @var callable
   */
  private $factory;

  /**
   * @param callable $factory
   */
  public function __construct($factory) {
    $this->factory = $factory;
  }

  /**
   * {@inheritdoc}
   */
  public function definitionGetConfigurator(array $definition, CfrContextInterface $context = NULL) {
    if (NULL === $this->instance) {
      $this->instance = \call_user_func($this->factory);
    }
    return $this->instance->definitionGetConfigurator($definition, $context);
  }

}
