<?php

namespace Drupal\cfrrealm\TypeToCfrFamily;

use Drupal\cfrapi\Context\CfrContextInterface;
use Drupal\cfrfamily\DefmapToCfrFamily\DefmapToCfrFamilyInterface;
use Drupal\cfrrealm\TypeToDefmap\TypeToDefmapInterface;

class TypeToCfrFamily_ViaDefmap implements TypeToCfrFamilyInterface {

  /**
   * @var \Drupal\cfrrealm\TypeToDefmap\TypeToDefmapInterface
   */
  private $typeToDefmap;

  /**
   * @var \Drupal\cfrfamily\DefmapToCfrFamily\DefmapToCfrFamilyInterface
   */
  private $defmapToCfrFamily;

  /**
   * @param \Drupal\cfrrealm\TypeToDefmap\TypeToDefmapInterface $typeToDefmap
   * @param \Drupal\cfrfamily\DefmapToCfrFamily\DefmapToCfrFamilyInterface $defmapToCfrFamily
   */
  public function __construct(TypeToDefmapInterface $typeToDefmap, DefmapToCfrFamilyInterface $defmapToCfrFamily) {
    $this->typeToDefmap = $typeToDefmap;
    $this->defmapToCfrFamily = $defmapToCfrFamily;
  }

  /**
   * {@inheritdoc}
   */
  public function typeGetCfrFamily($type, CfrContextInterface $context = NULL) {
    $defmap = $this->typeToDefmap->typeGetDefmap($type);
    return $this->defmapToCfrFamily->defmapGetCfrFamily($defmap, $context);
  }

}
