<?php

namespace Drupal\cfrrealm\TypeToConfigurator;

use Drupal\cfrapi\Context\CfrContextInterface;
use Drupal\cfrrealm\TypeToCfrFamily\TypeToCfrFamilyInterface;

class TypeToConfigurator_ViaCfrFamily implements TypeToConfiguratorInterface {

  /**
   * @var \Drupal\cfrrealm\TypeToCfrFamily\TypeToCfrFamilyInterface
   */
  private $typeToCfrFamily;

  /**
   * @param \Drupal\cfrrealm\TypeToCfrFamily\TypeToCfrFamilyInterface $typeToCfrFamily
   */
  public function __construct(TypeToCfrFamilyInterface $typeToCfrFamily) {
    $this->typeToCfrFamily = $typeToCfrFamily;
  }

  /**
   * {@inheritdoc}
   */
  public function typeGetConfigurator($type, CfrContextInterface $context = NULL) {
    return $this->typeToCfrFamily->typeGetCfrFamily($type, $context)->getFamilyConfigurator();
  }

  /**
   * {@inheritdoc}
   */
  public function typeGetOptionalConfigurator($type, CfrContextInterface $context = NULL, $defaultValue = NULL) {
    return $this->typeToCfrFamily->typeGetCfrFamily($type, $context)->getOptionalFamilyConfigurator($defaultValue);
  }

}
