<?php

namespace Drupal\cfrreflection\CfrGen\ParamToConfigurator;

use Drupal\cfrapi\Context\CfrContextInterface;
use Drupal\cfrrealm\TypeToConfigurator\TypeToConfiguratorInterface;

class ParamToConfigurator implements ParamToConfiguratorInterface {

  /**
   * @var \Drupal\cfrrealm\TypeToConfigurator\TypeToConfiguratorInterface
   */
  private $interfaceToConfigurator;

  /**
   * @param \Drupal\cfrrealm\TypeToConfigurator\TypeToConfiguratorInterface $interfaceToConfigurator
   */
  public function __construct(TypeToConfiguratorInterface $interfaceToConfigurator) {
    $this->interfaceToConfigurator = $interfaceToConfigurator;
  }

  /**
   * {@inheritdoc}
   */
  public function paramGetConfigurator(\ReflectionParameter $param, CfrContextInterface $context = NULL) {
    $typeHintReflectionClassLike = $param->getClass();
    if (!$typeHintReflectionClassLike) {
      return NULL;
    }
    if (!$param->isOptional()) {
      return $this->interfaceToConfigurator->typeGetConfigurator(
        $typeHintReflectionClassLike->getName(),
        $context);
    }
    try {
      $default = $param->getDefaultValue();
    }
    catch (\ReflectionException $e) {
      throw new \RuntimeException('Unexpected exception.');
    }
    return $this->interfaceToConfigurator->typeGetOptionalConfigurator(
      $typeHintReflectionClassLike->getName(),
      $context,
      $default);
  }

}
